// LL_USB_cDlg.cpp : implementation file
//

#include "stdafx.h"
#include "LL_USB_c.h"
#include "LL_USB_cDlg.h"
#include "ScanDataDlg.h"

//Last modified: 9-29-03

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

HWND  hMainDlg;
CLL_USB_cDlg* pMainDlg = NULL;
ScanDataDlg* pScanDataDlg = NULL;

void DisplayErrorString(CLL_USB_cDlg* pDlg, UINT usDevID);
void DisableControls(CLL_USB_cDlg* pDlg);
void EnableControls(CLL_USB_cDlg* pDlg);

BOOLEAN fDlgMsgBoxShownOnce = FALSE;

//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
// ###  INITIALIZATION   INITIALIZATION  INITIALIZATION  INITIALIZATION  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== InitThreadCall FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
ULONG  CALLBACK InitThreadCall(LPVOID _pDlg)
{

	CLL_USB_cDlg* pDlg = (CLL_USB_cDlg*) _pDlg;
	DisableControls(pDlg);

	// use this for single device since it's quicker.
	// however note that it always uses index 0 of your
	// device list. so if you have multiple devices and
	// want to use this to initialize one at a time, be
	// sure to use and update your lists accordingly.
	if(pDlg->pLocalDevClass_USB->bCurNumDevices == 1)
	{
		if(pDlg->pLocalDevClass_USB->pMyLL_USB == NULL)
			pDlg->pLocalDevClass_USB->pMyLL_USB = new MyLL_USB();
		
		BOOLEAN fInitSuccess = FALSE;
		fInitSuccess = pDlg->pLocalDevClass_USB->pMyLL_USB->Init 
			(pDlg->pLocalDevClass_USB->ausDevID[0], 
						pDlg->pLocalDevClass_USB->abChan[0], 
						&pDlg->pLocalDevClass_USB->adblDevRate[0]);
		if(!fInitSuccess)
		{
			// The init error will be detected and handled below,
			//  but something else can be done here too if desired.
		}
	}

	// use this for multiple devices. When it's finished
	// check to see if all of the original device ID's
	// are still in the list. Those that failed to iniitialize
	// will be set to 0 in the list before the constructor returns.
	if(pDlg->pLocalDevClass_USB->bCurNumDevices > 1)
	{
		pDlg->pLocalDevClass_USB->pMyLL_USB = new MyLL_USB();
		pDlg->pLocalDevClass_USB->pMyLL_USB->Init(pDlg->pLocalDevClass_USB->ausDevID, 
						pDlg->pLocalDevClass_USB->abChan, 
						pDlg->pLocalDevClass_USB->adblDevRate);
	}


	pDlg->pLocalDevClass_USB->fInitThreadShouldExit = TRUE;
	pDlg->KillTimer(pDlg->uiTimerInit);

	EnableControls(pDlg);

	if(pDlg->pLocalDevClass_USB->usDefDevID < 4990)
	{
		CWnd* pDacCombo = pDlg->GetDlgItem(IDC_COMBO_DAC);
		pDacCombo->EnableWindow(FALSE);
		CWnd* pDacSend = pDlg->GetDlgItem(IDC_BTN_SEND_ANALOGOUT);
		pDacSend->EnableWindow(FALSE);
	}
	else
	{
	}


	CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;
	cf.crTextColor = RGB(0, 0, 0); 
	pDlg->pRichEditMsgs->SetDefaultCharFormat(cf);

	UINT uiErrorCode;
	pDlg->pLocalDevClass_USB->pMyLL_USB->GetLastAnyError(&uiErrorCode);

	if(uiErrorCode & ERR_FAILED_INIT)
	{
		pDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, 
		"FAILED TO INITIALIZE:\n"
		"1.) Check device connection, and proper placement of device driver and DLL.\n"
		"2.) Try running our VerChk.exe utility for driver proper driver and DLL compatibility and placement on your computer's disk drive.\n");
	}
	else
		pDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, "Initialized - Press any button");

	pDlg->m_ProgressCntrl.SetPos(0);
	pDlg->m_usProgressCurPos = 0;

	return 1;
}



//****************************************************************\
//================================================================*\
//==== OnBtnInitAll FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnInitAll() 
{
	CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;

	if(!pLocalDevClass_USB->usDefDevID)
	{ 
		SetWindowText(" LL_USB    Failed to initialize");
		SetDlgItemText(IDC_RICHEDIT_MSGS, "No valid ID in INI file");
		cf.crTextColor = RGB(255, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		return; 
	}

	m_ProgressCntrl.SetPos(0); m_usProgressMax = 100; m_ProgressCntrl.SetRange(0,m_usProgressMax); m_ProgressCntrl.SetStep(1); m_usProgressCurPos = 0;

	SetTimer(uiTimerInit,50, 0);

	SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
	cf.crTextColor = RGB(255, 0, 0); 
	pRichEditMsgs->SetDefaultCharFormat(cf);

	pLocalDevClass_USB->hInitThreadCall = CreateThread(NULL, 0, InitThreadCall, this, 0, &pLocalDevClass_USB->dwInitThreadCallID);

	SetThreadPriority(pLocalDevClass_USB->hInitThreadCall, THREAD_PRIORITY_NORMAL);
	if(!pLocalDevClass_USB->hInitThreadCall)
	{
		MessageBox("Could not create INIT thread", " ERROR -----", 0);
		return;
	}
}


//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
// ## CONTROL ENABLE/DISABLE    CONTROL ENABLE/DISABLE  CONTROL ENABLE/DISABLE #####  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== OnBtnInitAll FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnTimer(UINT nIDEvent) 
{
	m_ProgressCntrl.StepIt(); m_usProgressCurPos++;
	if(m_usProgressCurPos >= m_usProgressMax) { m_ProgressCntrl.SetPos(0); m_usProgressCurPos = 0; }
	CDialog::OnTimer(nIDEvent);
}



//****************************************************************\
//================================================================*\
//==== DisableControls FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
void DisableControls(CLL_USB_cDlg* pDlg)
{
	//return;
	CWnd* pGetConvBtn		= pDlg->GetDlgItem(IDC_BTN_GET_ONE_VOLTAGE);	pGetConvBtn->EnableWindow(FALSE); 
	CWnd* pSendDigoutBtn	= pDlg->GetDlgItem(IDC_BTN_SEND_DIGOUT);		pSendDigoutBtn->EnableWindow(FALSE); 

	CWnd* pGetDiginBtn		= pDlg->GetDlgItem(IDC_BTN_GET_DIGITAL_INPUT);	pGetDiginBtn->EnableWindow(FALSE);

	CWnd* pSendDAC_Btn		= pDlg->GetDlgItem(IDC_BTN_SEND_ANALOGOUT);		pSendDAC_Btn->EnableWindow(FALSE);
	CWnd* pDAC_Edit			= pDlg->GetDlgItem(IDC_EDIT_ANALOGOUT);			pDAC_Edit->EnableWindow(FALSE);
	CWnd* pDAC_Combo		= pDlg->GetDlgItem(IDC_COMBO_DAC);				pDAC_Combo->EnableWindow(FALSE);

	CWnd* pScanBtn			= pDlg->GetDlgItem(IDC_BTN_START_STOP_SCANNING); pScanBtn->EnableWindow(FALSE);
	CWnd* pInitBtn			= pDlg->GetDlgItem(IDC_BTN_INIT_ALL);			pInitBtn->EnableWindow(FALSE);
	CWnd* pExitBtn			= pDlg->GetDlgItem(IDC_BTN_EXIT);				pExitBtn->EnableWindow(FALSE);

	CWnd* pDevCombo			= pDlg->GetDlgItem(IDC_COMBO_DEV_ID);			pDevCombo->EnableWindow(FALSE);
	CWnd* pChanCombo		= pDlg->GetDlgItem(IDC_COMBO_DEV_CHAN);			pChanCombo->EnableWindow(FALSE);
	CWnd* pRateCombo		= pDlg->GetDlgItem(IDC_COMBO_DEV_RATE);			pRateCombo->EnableWindow(FALSE);
	
	CWnd* pScanMultiChanChk = pDlg->GetDlgItem(IDC_CHK_SCAN_MULTI_CHAN);	pScanMultiChanChk->EnableWindow(FALSE);
	CWnd* pScanCalChk		= pDlg->GetDlgItem(IDC_CHK_SCAN_CAL_SCAN);		pScanCalChk->EnableWindow(FALSE);
	CWnd* pScanDiginChk		= pDlg->GetDlgItem(IDC_CHK_SCAN_DIGIN);			pScanDiginChk->EnableWindow(FALSE);
	CWnd* pScanNumChansChk	= pDlg->GetDlgItem(IDC_COMBO_SCAN_NUM_CHANS);	pScanNumChansChk->EnableWindow(FALSE);
}



//****************************************************************\
//================================================================*\
//==== EnableControls FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
void EnableControls(CLL_USB_cDlg* pDlg)
{
	CWnd* pGetConvBtn = pDlg->GetDlgItem(IDC_BTN_GET_ONE_VOLTAGE);		pGetConvBtn->EnableWindow(TRUE); 
	CWnd* pSendDigoutBtn = pDlg->GetDlgItem(IDC_BTN_SEND_DIGOUT);		pSendDigoutBtn->EnableWindow(TRUE); 

	CWnd* pGetDiginBtn = pDlg->GetDlgItem(IDC_BTN_GET_DIGITAL_INPUT);	pGetDiginBtn->EnableWindow(TRUE);

	//Check this one first
	if(pDlg->pLocalDevClass_USB->usDefDevID > 4990)
	{
		CWnd* pSendDAC_Btn = pDlg->GetDlgItem(IDC_BTN_SEND_ANALOGOUT);		
		pSendDAC_Btn->EnableWindow(TRUE);
		CWnd* pDAC_Edit = pDlg->GetDlgItem(IDC_EDIT_ANALOGOUT);				
		pDAC_Edit->EnableWindow(TRUE);
		CWnd* pDAC_Combo = pDlg->GetDlgItem(IDC_COMBO_DAC);				
		pDAC_Combo->EnableWindow(TRUE);

	}

	CWnd* pScanBtn			= pDlg->GetDlgItem(IDC_BTN_START_STOP_SCANNING); pScanBtn->EnableWindow(TRUE);
	CWnd* pInitBtn			= pDlg->GetDlgItem(IDC_BTN_INIT_ALL);			pInitBtn->EnableWindow(TRUE);
	CWnd* pExitBtn			= pDlg->GetDlgItem(IDC_BTN_EXIT);				pExitBtn->EnableWindow(TRUE);

	CWnd* pDevCombo			= pDlg->GetDlgItem(IDC_COMBO_DEV_ID);			pDevCombo->EnableWindow(TRUE);
	CWnd* pChanCombo		= pDlg->GetDlgItem(IDC_COMBO_DEV_CHAN);			pChanCombo->EnableWindow(TRUE);
	CWnd* pRateCombo		= pDlg->GetDlgItem(IDC_COMBO_DEV_RATE);			pRateCombo->EnableWindow(TRUE);

	CWnd* pScanMultiChanChk = pDlg->GetDlgItem(IDC_CHK_SCAN_MULTI_CHAN);	pScanMultiChanChk->EnableWindow(TRUE);
	CWnd* pScanCalChk		= pDlg->GetDlgItem(IDC_CHK_SCAN_CAL_SCAN);		pScanCalChk->EnableWindow(TRUE);
	CWnd* pScanDiginChk		= pDlg->GetDlgItem(IDC_CHK_SCAN_DIGIN);			pScanDiginChk->EnableWindow(TRUE);
	CWnd* pScanNumChansChk	= pDlg->GetDlgItem(IDC_COMBO_SCAN_NUM_CHANS);	pScanNumChansChk->EnableWindow(TRUE);


	if(		(pDlg->pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_SCAN) 
		||	(pDlg->pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_DIGIN_SCAN))
	{ 
		pDlg->m_pMultiScanChanChkBox.SetCheck(0);
		pDlg->m_pCalScanChkBox.EnableWindow(FALSE);
		pDlg->UpdateNumScanChansCntrl();
	}
	else
	{
		pDlg->m_pMultiScanChanChkBox.SetCheck(1); pDlg->m_pCalScanChkBox.EnableWindow(TRUE);
		if(		(pDlg->pLocalDevClass_USB->m_bDefScanType == CMND_MULTI_CHAN_CAL_SCAN) ||	(pDlg->pLocalDevClass_USB->m_bDefScanType == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
		{ pDlg->m_pCalScanChkBox.SetCheck(1); }
		pDlg->UpdateNumScanChansCntrl();
	}
}


//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
// ## SINGLE VOLTAGE AND DIGITAL I/O     SINGLE VOLTAGE AND DIGITAL I/O  ###########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//****************************************************************\
//================================================================*\
//==== OnBtnGetOneVoltage FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnGetOneVoltage() 
{
	if(pLocalDevClass_USB->pMyLL_USB == NULL) return;

	DOUBLE dblVoltage;
	if(!pLocalDevClass_USB->pMyLL_USB->GetOneVoltage(pLocalDevClass_USB->usDefDevID, &dblVoltage)) 
	{ 
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID);
		return; 
	}

	char bbuff[128];
	sprintf(bbuff, "%2.5lf", dblVoltage);
	SetDlgItemText(IDC_EDIT_SINGLE_VOLTAGE, bbuff);
}



//****************************************************************\
//================================================================*\
//==== OnBtnSendDigout FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnSendDigout() 
{
	if(pLocalDevClass_USB->pMyLL_USB == NULL) return;

	char buff[128] = {0};
	GetDlgItemText(IDC_EDIT_DIGOUT_VAL, buff, sizeof(buff));
	if(strlen(buff) == 0){ MessageBox("You must enter valid a value to send", "", 0); return; }

	BYTE bDigOutVal = (BYTE)atoi(buff);

	if(!pLocalDevClass_USB->pMyLL_USB->SendDigitalOutput(pLocalDevClass_USB->usDefDevID, bDigOutVal))
	{ 
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID);
		return; 
	}
}



//****************************************************************\
//================================================================*\
//==== OnBtnGetDigitalInput FUNCTION ==============================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnGetDigitalInput() 
{
	if(pLocalDevClass_USB->pMyLL_USB == NULL) return;

	if(!pLocalDevClass_USB->pMyLL_USB->GetDigitalInput(pLocalDevClass_USB->usDefDevID, &pLocalDevClass_USB->bLastDigin[pLocalDevClass_USB->bCurDevListIndex])) 
	{ 
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID); return; 
	}
	char buff[128];
	sprintf(buff, "%d", pLocalDevClass_USB->bLastDigin[pLocalDevClass_USB->bCurDevListIndex]);
	SetDlgItemText(IDC_EDIT_DIGIN_VAL, buff);
}



//****************************************************************\
//================================================================*\
//==== OnEditchangeComboDac FUNCTION ==============================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnEditchangeComboDac() 
{
	char buff[128]; sprintf(buff, "%d", pLocalDevClass_USB->m_bDefDAC);
	SetDlgItemText(IDC_COMBO_DAC, buff);
}



//****************************************************************\
//================================================================*\
//==== OnBtnSendAnalogout FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnSendAnalogout() 
{
	if(pLocalDevClass_USB->pMyLL_USB == NULL)
	{
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Analog output not sent - not initialized");
		return;
	}

	char buff[128] = {0}; GetDlgItemText(IDC_COMBO_DAC, buff, sizeof(buff)); BYTE bDAC = atoi(buff);

	CString cStr; DOUBLE dblVoltageDAC;
	m_VoltsDAC.GetWindowText(cStr); dblVoltageDAC = atof(cStr);
	if(dblVoltageDAC > 5.0) dblVoltageDAC = 5.0;
	else if(dblVoltageDAC < -5.0) dblVoltageDAC = -5;

	cStr.Format("%5.4f",dblVoltageDAC); m_VoltsDAC.SetWindowText(cStr);
	
	if(!pLocalDevClass_USB->pMyLL_USB->SendAnalogOut(pLocalDevClass_USB->usDefDevID, bDAC, dblVoltageDAC))
	{ 
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID);
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Failed to send analog output!");
		return; 
	}
	SetDlgItemText(IDC_RICHEDIT_MSGS, "Analog output sent");
}



//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
// ###  SCANNING RELATED   SCANNING RELATED  SCANNING RELATED  SCANNING RELATED  ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/
//**************************************************************************\
//===========================================================================
//==== ScanThread_TYPE1 THREAD ==============================================
//===========================================================================
//**************************************************************************/
// One of 2 scan data reading thread options. See scan startup for details.
// This thread uses unstructured arguments when reading the scan data. Although
//  this may offer more flexibility, it is also a little more complex to decode
//  the data buffer than the other forms using the structured scan format for
//  reading the scan information. Although only the non-digital input type scans
//  are shown for this type, the digital input type scan only requires the adding
//  of an additional buffer for the return of the digital input values that 
//  correspond to each channels data response. 
ULONG CALLBACK ScanThread_TYPE1(LPVOID _pMainClass)
{
	MyLL_USB* pMyLL_USB = (MyLL_USB*) _pMainClass;

	pMainDlg->SetDlgItemText(IDC_BTN_START_STOP_SCANNING, "Stop scan");
	pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, "");

	DOUBLE dblVoltage, dblVoltageOffset;
	UINT* uiDataBuff;
	clock_t clockRead, clockDisplay;
	BYTE bLastDigin, bScanType, bNumChans_Local = 1;
	BOOLEAN fDoScanProcess = FALSE, fIsCalScan = FALSE;
	USHORT usNumPntsToReadMax = 10, usNumPntsToReadMin = 10, usNumPntsRead = 0;
	UINT uiStatusFlags, uiPntsInBuff, uiTmpCnt = 0, uiTotalPntsRead = 0, uiCurDataBuffSz = 10, uiPntsInBuff_TEMP, uiNumScans = 100, uiTotalBuffSize;

	char bbuff[128];

	#define OKAY_TO_READ_LESS TRUE
	clockRead = clock() + 50; clockDisplay = clock() + 500;

	// just to make the pointer shorter and easier to read in the code.
	LocalDevClass_USB* pDev = pMainDlg->pLocalDevClass_USB;

	bScanType = pDev->m_bScanType[pDev->bCurDevListIndex];
	if((bScanType != CMND_SINGLE_CHAN_SCAN) && (bScanType != CMND_SINGLE_CHAN_DIGIN_SCAN))
	{
		bNumChans_Local =  pDev->m_bNumScanChans[pDev->bCurDevListIndex];
		DOUBLE dblRateTemp = pDev->adblDevRate[pDev->bCurDevListIndex];
		dblRateTemp	= dblRateTemp / (double)(bNumChans_Local * 5);
		sprintf(bbuff, "%4.1lf", dblRateTemp);
		pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DATA_RATE, bbuff);
	}
	else
	{
		sprintf(bbuff, "%4.1lf", pDev->dblDefRate);
		pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DATA_RATE, bbuff);
	}

	if( (pDev->m_bScanType[pDev->bCurDevListIndex] == CMND_MULTI_CHAN_CAL_SCAN)
	   || (pDev->m_bScanType[pDev->bCurDevListIndex] == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
			fIsCalScan = TRUE;

	uiTotalBuffSize = uiNumScans * bNumChans_Local;
	uiDataBuff = new UINT[uiTotalBuffSize];

	while(TRUE)
	{
		if(pDev->fStartThreadTakingData[pDev->bCurDevListIndex] == TRUE)
		{ fDoScanProcess = TRUE; break; }
		
		if((pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) == TRUE) break;
		{ break; }
	}

	if(fDoScanProcess)
	while(TRUE)
	{
		if((pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) == TRUE) break;

		if(pMyLL_USB->GetScanData(
			pDev->usDefDevID, usNumPntsToReadMax, usNumPntsToReadMin, 
			&usNumPntsRead, uiDataBuff, TRUE, &uiStatusFlags, &uiPntsInBuff, &bLastDigin))
		{
			if(pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) break;

			uiTotalPntsRead = uiTotalPntsRead + usNumPntsRead;

			if(clock() > clockDisplay)
			{
				sprintf(bbuff, "0x%X", uiStatusFlags);
				pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_STATUS, bbuff);

				if((uiStatusFlags & SCAN_HALTED) || (uiStatusFlags & SCAN_DEVICE_UNRECOVERABLE_ERROR))
				{
					pMainDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, "SCAN HALTED:\nIf no other devices are scanning, press 'Stop Scan' complete scan session\nPOSSIBLE ERRORS:\n1.) Device USB cable disconnect or loss of power.\n2.) Possible O/S related error.\n");
					break;
				}
			
				sprintf(bbuff, "%u", uiPntsInBuff);
				pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_PNTS_IN_BUFF, bbuff);

				if(usNumPntsRead)
				{
					sprintf(bbuff, "%u", uiTotalPntsRead);
					pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_PNTS_READ, bbuff);

					sprintf(bbuff, "%d", bLastDigin);
					pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DIGIN, bbuff);


					if((pDev->m_bScanType[pDev->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
					{
						dblVoltage = ((INT)uiDataBuff[0] - 8388608) * 0.00000059604645;

						sprintf(bbuff, "% 2.5lf", dblVoltage);
						switch(pDev->bDefChan)
						{
							case 0: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff); break;
							case 1: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff); break;
							case 2: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN2, bbuff); break;
							case 3: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN3, bbuff); break;
							case 4: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN4, bbuff); break;
							case 5: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN5, bbuff); break;
							case 6: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); break;
							case 7: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); break;
						}
					}
					else
					{
						bNumChans_Local =  pDev->m_bNumScanChans[pDev->bCurDevListIndex];
						if(pDev->usDefDevID < 4990)
						{
							dblVoltage = ((INT)uiDataBuff[0] - 8388608) * 0.00000059604645; 
							if(bNumChans_Local > 1) //6-23-02
							if(fIsCalScan)
							{
								switch(bNumChans_Local)
								{
									case 2: 
										dblVoltageOffset = ((INT)uiDataBuff[1] - 8388608) * 0.00000059604645;
										dblVoltage = dblVoltage - dblVoltageOffset;
										break;
									case 3: 
										dblVoltageOffset = ((INT)uiDataBuff[2] - 8388608) * 0.00000059604645;
										dblVoltage = dblVoltage - dblVoltageOffset;
										break;
									case 4: 
										dblVoltageOffset = ((INT)uiDataBuff[3] - 8388608) * 0.00000059604645;
										dblVoltage = dblVoltage - dblVoltageOffset;
										break;
								}
								dblVoltage = dblVoltage - dblVoltageOffset;
							}
							
							sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff);
							while(TRUE)
							{
								// 2 channel
								dblVoltage = ((INT)uiDataBuff[1] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 2)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff);
								if(bNumChans_Local < 3) break;

								// 3 channels
								dblVoltage = ((INT)uiDataBuff[2] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 3)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); 
								if(bNumChans_Local < 4) break;
							
								// 4 channels
								dblVoltage = ((INT)uiDataBuff[3] - 8388608) * 0.00000059604645; 
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); 
								break;
							}
						}
						else
						{
							dblVoltage = ((INT)uiDataBuff[0] - 8388608) * 0.00000059604645; 
							if(bNumChans_Local > 1) //6-23-02
							if(fIsCalScan)
							{
								switch(bNumChans_Local)
								{
									case 2: dblVoltageOffset = ((INT)uiDataBuff[1] - 8388608) * 0.00000059604645; break;
									case 3: dblVoltageOffset = ((INT)uiDataBuff[2] - 8388608) * 0.00000059604645; break;
									case 4: dblVoltageOffset = ((INT)uiDataBuff[3] - 8388608) * 0.00000059604645; break;
									case 5: dblVoltageOffset = ((INT)uiDataBuff[4] - 8388608) * 0.00000059604645; break;
									case 6: dblVoltageOffset = ((INT)uiDataBuff[5] - 8388608) * 0.00000059604645; break;
									case 7: dblVoltageOffset = ((INT)uiDataBuff[6] - 8388608) * 0.00000059604645; break;
									case 8: dblVoltageOffset = ((INT)uiDataBuff[7] - 8388608) * 0.00000059604645; break;
								}
								dblVoltage = dblVoltage - dblVoltageOffset;
							}
							
							sprintf(bbuff, "% 2.5lf", dblVoltage);
							pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff);

							if(bNumChans_Local > 1) //6-23-02
							while(TRUE)
							{
								// 2 channel
								dblVoltage = ((INT)uiDataBuff[1] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 2)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff);
								if(bNumChans_Local < 3) break;

								// 3 channels
								dblVoltage = ((INT)uiDataBuff[2] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 3)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN2, bbuff); 
								if(bNumChans_Local < 4) break;

								// 4 channels
								dblVoltage = ((INT)uiDataBuff[3] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 4)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN3, bbuff); 
								if(bNumChans_Local < 5) break;

								// 5 channels
								dblVoltage = ((INT)uiDataBuff[4] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 5)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN4, bbuff); 
								if(bNumChans_Local < 6) break;
								
								// 6 channels
								dblVoltage = ((INT)uiDataBuff[5] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 6)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN5, bbuff); 
								if(bNumChans_Local < 7) break;
								
								// 7 channels
								dblVoltage = ((INT)uiDataBuff[6] - 8388608) * 0.00000059604645;
								if(fIsCalScan && (bNumChans_Local > 7)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); 
								if(bNumChans_Local < 8) break;
								
								// 8 channels
								dblVoltage = ((INT)uiDataBuff[7] - 8388608) * 0.00000059604645; 
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); 
								break;
							}
						}
					}
				}
				clockDisplay = clock() + 200;
			}

			uiPntsInBuff_TEMP = uiPntsInBuff;
			// set some kind of maximum for each read

			if(uiPntsInBuff_TEMP > uiTotalBuffSize) 
			{ uiPntsInBuff_TEMP = uiTotalBuffSize; }

			if(uiPntsInBuff_TEMP > usNumPntsToReadMin)
			{ 	usNumPntsToReadMax = uiPntsInBuff_TEMP; }
		}
		else
		{
			if((uiStatusFlags & SCAN_HALTED) || (uiStatusFlags & SCAN_DEVICE_UNRECOVERABLE_ERROR))
			{
				pMainDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, "SCAN HALTED:\nIf no other devices are scanning, press 'Stop Scan' complete scan session\nPOSSIBLE ERRORS:\n1.) Device USB cable disconnect or loss of power.\n2.) Possible O/S related error.\n");
				sprintf(bbuff, "0x%X", uiStatusFlags); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_STATUS, bbuff);

				pDev->m_afDevScanning[pDev->bCurDevListIndex] = FALSE;

				BOOLEAN fAnyDevScanning = FALSE;
				for(BYTE bIndex = 0; bIndex < 32; bIndex++)
				{
					if(pDev->m_afDevScanning[pDev->bCurDevListIndex] == TRUE)
					{ fAnyDevScanning = TRUE; break; }
				}

				if(fAnyDevScanning) pDev->m_fAnyDevScanning = TRUE;
				else pDev->m_fAnyDevScanning = FALSE;

				break;
			}
		}
	}
	delete[]uiDataBuff;

	pDev->fExitScanThreadRequest[pDev->bCurDevListIndex] = FALSE;
	pDev->fScanThreadRunning[pDev->bCurDevListIndex] = FALSE;

	return 1;
}



//**************************************************************************\
//===========================================================================
//==== ScanThread_TYPE2 THREAD ==============================================
//===========================================================================
//**************************************************************************/
// One of 2 scan data reading thread options. See scan startup for details.
// This thread reads data using a structured data type format. Each read uses 
//  two structures. One argument passed to the read function is an array of 
//  structures that represents a a Scan of data and digital input values for 
//  each channel  in the Scan. The second argument is a single pointer to
//  a structure that contains scan status information used both for communication 
//  to the read and back from the read.
ULONG CALLBACK ScanThread_TYPE2(LPVOID _pMainClass)
{
	#define OKAY_TO_READ_LESS TRUE
	MyLL_USB* pMyLL_USB = (MyLL_USB*) _pMainClass;

	pMainDlg->SetDlgItemText(IDC_BTN_START_STOP_SCANNING, "Stop scan");
	pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, "");

	DOUBLE dblVoltage, dblVoltageOffset;
	BYTE bScanType, bNumChans_Local = 1;
	BOOLEAN fDoScanProcess = FALSE, fIsCalScan = FALSE;

	USHORT usScanBuffSize = 100;
	USHORT usNumScansToReadMax = 100, usNumScanToReadMin = 10;

	PSCAN_INFO_USB pScanInfo = new SCAN_INFO_USB[1];
	PSCAN_DATA_USB pScanData = new SCAN_DATA_USB[usScanBuffSize];

	clock_t clockRead, clockDisplay;

	//SHORT usNumPntsToReadMax = 10, usNumPntsToReadMin = 10, usNumPntsRead = 0;
	//UINT uiStatusFlags, uiPntsInBuff, uiTotalPntsRead = 0, uiCurDataBuffSz = 10, uiPntsInBuff_TEMP, uiNumScans = 100, uiTotalBuffSize;
	UINT uiTotalPntsRead = 0;
	USHORT usScansInBuff_TEMP;

	char bbuff[128];

	clockRead = clock() + 50; clockDisplay = clock() + 500;

	LocalDevClass_USB* pDev = pMainDlg->pLocalDevClass_USB;

	bScanType = pDev->m_bScanType[pDev->bCurDevListIndex];
	if((bScanType != CMND_SINGLE_CHAN_SCAN) && (bScanType != CMND_SINGLE_CHAN_DIGIN_SCAN))
	{ 
		bNumChans_Local =  pDev->m_bNumScanChans[pDev->bCurDevListIndex]; 
		DOUBLE dblRateTemp = pDev->adblDevRate[pDev->bCurDevListIndex]; 
		dblRateTemp	= dblRateTemp / (double)(bNumChans_Local * 5); 
		sprintf(bbuff, "%4.1lf", dblRateTemp); 
		pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DATA_RATE, bbuff); 
	}
	else
	{ 
		sprintf(bbuff, "%4.1lf", pDev->dblDefRate); 
		pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DATA_RATE, bbuff); 
	}

	if( (pDev->m_bScanType[pDev->bCurDevListIndex] == CMND_MULTI_CHAN_CAL_SCAN)
	   || (pDev->m_bScanType[pDev->bCurDevListIndex] == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
			fIsCalScan = TRUE;

	while(TRUE)
	{ if(pDev->fStartThreadTakingData[pDev->bCurDevListIndex] == TRUE) { fDoScanProcess = TRUE; break; }
		if((pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) == TRUE) break; }

	pScanInfo->usDevID = pDev->usDefDevID;
	pScanInfo->usNumScansMax = usScanBuffSize;
	pScanInfo->usNumScansMin = 10;
	pScanInfo->fOkayToReadLess = TRUE;
	pScanInfo->uiStatusFlags = 0;
	pScanInfo->uiNumScansInBuff = 0;
	pScanInfo->usNumScansRead = 0;

	if(fDoScanProcess)
	while(TRUE)
	{
		if((pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) == TRUE) break;

		if(pMyLL_USB->GetScanData(pScanInfo, pScanData))
		{
			if(pDev->fExitScanThreadRequest[pDev->bCurDevListIndex]) break;

			uiTotalPntsRead = uiTotalPntsRead + (pScanInfo->usNumScansRead * bNumChans_Local);

			if(clock() > clockDisplay)
			{
				sprintf(bbuff, "0x%X", pScanInfo->uiStatusFlags);
				pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_STATUS, bbuff);

				if((pScanInfo->uiStatusFlags & SCAN_HALTED) || (pScanInfo->uiStatusFlags & SCAN_DEVICE_UNRECOVERABLE_ERROR))
				{
					pMainDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, "SCAN HALTED:\nIf no other devices are scanning, press 'Stop Scan' complete scan session\nPOSSIBLE ERRORS:\n1.) Device USB cable disconnect or loss of power.\n2.) Possible O/S related error.\n");
					break;
				}
			
				sprintf(bbuff, "%u", pScanInfo->uiNumScansInBuff / bNumChans_Local);
				pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_PNTS_IN_BUFF, bbuff);

				if(pScanInfo->usNumScansRead != 0)
				{
					//sprintf(bbuff, "%u", pScanInfo->usNumScansRead);
					sprintf(bbuff, "%u", uiTotalPntsRead);
					pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_PNTS_READ, bbuff);

					sprintf(bbuff, "%d", pScanInfo->bLastDigin);
					pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_DIGIN, bbuff);

					if((pDev->m_bScanType[pDev->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
					{
						dblVoltage = (((INT)pScanData[0].bDataChan0) - 8388608) * 0.00000059604645;
						sprintf(bbuff, "% 2.5lf", dblVoltage);
						switch(pDev->bDefChan)
						{
							case 0: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff); break;
							case 1: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff); break;
							case 2: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN2, bbuff); break;
							case 3: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN3, bbuff); break;
							case 4: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN4, bbuff); break;
							case 5: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN5, bbuff); break;
							case 6: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); break;
							case 7: pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); break;
						}
					}
					else
					{
						if(pDev->usDefDevID < 4990)
						{
							bNumChans_Local =  pDev->m_bNumScanChans[pDev->bCurDevListIndex];
							dblVoltage = (((INT)pScanData[0].bDataChan0) - 8388608) * 0.00000059604645; 

							if(fIsCalScan)
							{
								switch(bNumChans_Local)
								{
									case 2: dblVoltageOffset = (((INT)pScanData[0].bDataChan1) - 8388608) * 0.00000059604645; break; 
									case 3: dblVoltageOffset = (((INT)pScanData[0].bDataChan6) - 8388608) * 0.00000059604645; break; 
									case 4: dblVoltageOffset = (((INT)pScanData[0].bDataChan7) - 8388608) * 0.00000059604645; break;
								}
								if(bNumChans_Local > 1) //6-23-02
									dblVoltage = dblVoltage - dblVoltageOffset;
							}
							sprintf(bbuff, "% 2.5lf", dblVoltage);
							pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff);

							if(bNumChans_Local > 1) //6-23-02
							while(TRUE)
							{
								// 2 channel
								//dblVoltage = ((INT)uiDataBuff[1] - 8388608) * 0.00000059604645;
								dblVoltage = (((INT)pScanData[0].bDataChan1) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 2)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff);
								if(bNumChans_Local < 3) break;

								// 3 channels
								//dblVoltage = ((INT)uiDataBuff[2] - 8388608) * 0.00000059604645;
								dblVoltage = (((INT)pScanData[0].bDataChan6) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 3)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); 
								if(bNumChans_Local < 4) break;
								
								// 4 channels
								//dblVoltage = ((INT)uiDataBuff[7] - 8388608) * 0.00000059604645; 
								dblVoltage = (((INT)pScanData[0].bDataChan7) - 8388608) * 0.00000059604645; 
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); 
								break;
							}
						}
						else
						{
							bNumChans_Local =  pDev->m_bNumScanChans[pDev->bCurDevListIndex];
							dblVoltage = (((INT)pScanData[0].bDataChan0) - 8388608) * 0.00000059604645; 
							if(fIsCalScan)
							{
								switch(bNumChans_Local)
								{
									case 2: dblVoltageOffset = (((INT)pScanData[0].bDataChan1) - 8388608) * 0.00000059604645; break;
									case 3: dblVoltageOffset = (((INT)pScanData[0].bDataChan2) - 8388608) * 0.00000059604645; break; 
									case 4: dblVoltageOffset = (((INT)pScanData[0].bDataChan3) - 8388608) * 0.00000059604645; break; 
									case 5: dblVoltageOffset = (((INT)pScanData[0].bDataChan4) - 8388608) * 0.00000059604645; break; 
									case 6: dblVoltageOffset = (((INT)pScanData[0].bDataChan5) - 8388608) * 0.00000059604645; break; 
									case 7: dblVoltageOffset = (((INT)pScanData[0].bDataChan6) - 8388608) * 0.00000059604645; break; 
									case 8: dblVoltageOffset = (((INT)pScanData[0].bDataChan7) - 8388608) * 0.00000059604645; break; 
								}
								if(bNumChans_Local > 1) //6-23-02
									dblVoltage = dblVoltage - dblVoltageOffset;
							}
							
							sprintf(bbuff, "% 2.5lf", dblVoltage);
							pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN0, bbuff);

							if(bNumChans_Local > 1) //6-23-02
							while(TRUE)
							{
								// 2 channel
								dblVoltage = (((INT)pScanData[0].bDataChan1) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 2)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN1, bbuff);
								if(bNumChans_Local < 3) break;

								// 3 channels
								dblVoltage = (((INT)pScanData[0].bDataChan2) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 3)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN2, bbuff); 
								if(bNumChans_Local < 4) break;

								// 4 channels
								dblVoltage = (((INT)pScanData[0].bDataChan3) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 4)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN3, bbuff); 
								if(bNumChans_Local < 5) break;
								
								// 5 channels
								dblVoltage = (((INT)pScanData[0].bDataChan4) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 5)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN4, bbuff); 
								if(bNumChans_Local < 6) break;

								// 6 channels
								dblVoltage = (((INT)pScanData[0].bDataChan5) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 6)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN5, bbuff); 
								if(bNumChans_Local < 7) break;

								// 7 channels
								dblVoltage = (((INT)pScanData[0].bDataChan6) - 8388608) * 0.00000059604645; 
								if(fIsCalScan && (bNumChans_Local > 7)) dblVoltage = dblVoltage - dblVoltageOffset;
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN6, bbuff); 
								if(bNumChans_Local < 8) break;

								// 8 channels
								dblVoltage = (((INT)pScanData[0].bDataChan7) - 8388608) * 0.00000059604645; 
								sprintf(bbuff, "% 2.5lf", dblVoltage); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_CHAN7, bbuff); 
								break;
							}
						}
					}
				}
				clockDisplay = clock() + 200;
			}
			
			usScansInBuff_TEMP = pScanInfo->uiNumScansInBuff;
			// set some kind of maximum for each read

			if(usScansInBuff_TEMP > usScanBuffSize) 
			{ usScansInBuff_TEMP = usScanBuffSize; }

			if(usScansInBuff_TEMP > pScanInfo->usNumScansMin)
			{ 	pScanInfo->usNumScansMax = usScansInBuff_TEMP; }
		}
		else
		{
			if((pScanInfo->uiStatusFlags & SCAN_HALTED) || (pScanInfo->uiStatusFlags & SCAN_DEVICE_UNRECOVERABLE_ERROR))
			{
				pMainDlg->SetDlgItemText(IDC_RICHEDIT_MSGS, "SCAN HALTED:\nIf no other devices are scanning, press 'Stop Scan' complete scan session\nPOSSIBLE ERRORS:\n1.) Device USB cable disconnect or loss of power.\n2.) Possible O/S related error.\n");
				sprintf(bbuff, "0x%X", pScanInfo->uiStatusFlags); pScanDataDlg->SetDlgItemText(IDC_EDIT_SD_SCAN_STATUS, bbuff);

				pDev->m_afDevScanning[pDev->bCurDevListIndex] = FALSE;

				BOOLEAN fAnyDevScanning = FALSE;
				for(BYTE bIndex = 0; bIndex < 32; bIndex++)
				{
					if(pDev->m_afDevScanning[pDev->bCurDevListIndex] == TRUE)
					{ fAnyDevScanning = TRUE; break; }
				}
				if(fAnyDevScanning)
					pDev->m_fAnyDevScanning = TRUE;
				else
					pDev->m_fAnyDevScanning = FALSE;

				break;
			}
		}
	}
	delete[]pScanInfo;
	delete[]pScanData;


	pDev->fExitScanThreadRequest[pDev->bCurDevListIndex] = FALSE;
	pDev->fScanThreadRunning[pDev->bCurDevListIndex] = FALSE;

	return 1;
}

//****************************************************************\
//================================================================*\
//==== OnBtnStartStopScanning FUNCTION ============================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnStartStopScanning() 
{
	if(pLocalDevClass_USB->pMyLL_USB == NULL) { return; }

	if(!pLocalDevClass_USB->pMyLL_USB->GetCurDevInitStatus(pLocalDevClass_USB->usDefDevID))
	{ MessageBox("Device not initialized", " ERROR -----", 0); return; }

	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;

	BOOLEAN fOkayToStartScan;
	BOOLEAN fScanning;
	pLocalDevClass_USB->pMyLL_USB->GetCurDevScanStatus(pLocalDevClass_USB->usDefDevID, &fOkayToStartScan, &fScanning); 

	if((fOkayToStartScan == TRUE) && (fScanning == FALSE)) 
	{
		// Don't let thread ask for any data yet.
		pLocalDevClass_USB->fStartThreadTakingData[pLocalDevClass_USB->bCurDevListIndex] = FALSE;

		DisableControls(this);

		pScanDataDlg->ShowWindow(SW_SHOW | SW_SHOWNORMAL);

		RECT rectMainDlg; RECT rectScanDatDlg; GetWindowRect(&rectMainDlg); pScanDataDlg->GetWindowRect(&rectScanDatDlg);
		int nWidth = rectScanDatDlg.right - rectScanDatDlg.left, nHeight = rectScanDatDlg.bottom - rectScanDatDlg.top, iNewX = rectMainDlg.left - nWidth, iNewY = rectMainDlg.top;
		pScanDataDlg->MoveWindow ( iNewX, iNewY, nWidth, nHeight, TRUE );

		CWnd* pCurScanChanDataBox = NULL; 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN0); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN2); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN3); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN4); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN5); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(FALSE); 
		pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(FALSE); 


		if(((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
			||	((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_DIGIN_SCAN))
		{
			switch(pLocalDevClass_USB->bDefChan)
			{
				case 0: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN0); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 1: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 2: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN2); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 3: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN3); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 4: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN4); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 5: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN5); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 6: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(TRUE); break;
				case 7: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(TRUE); break;
			}
		}
		else
		{
			pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN0); pCurScanChanDataBox->EnableWindow(TRUE); 

			char buff[128] = {0};
			GetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, buff, sizeof(buff));
			pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] = (BYTE)atoi(buff);

			if(pLocalDevClass_USB->usDefDevID < 4990)
			{
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 1) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 2) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 3) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(TRUE); }
			}
			else
			{
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 1) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 2) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN2); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 3) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN3); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 4) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN4); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 5) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN5); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 6) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(TRUE); }
				if(pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] > 7) { pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(TRUE); }
			}
		}

		pLocalDevClass_USB->fStartThreadTakingData[pLocalDevClass_USB->bCurDevListIndex] = FALSE;

		//Two scan data reading thread options below. One is more efficient when a single channel is being
		//  scanned and the other is more efficient when multiple channels are being scanned.
		if((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
			pLocalDevClass_USB->hScanThread[pLocalDevClass_USB->bCurDevListIndex] = CreateThread(NULL, 0, ScanThread_TYPE1, pLocalDevClass_USB->pMyLL_USB, 0, &pLocalDevClass_USB->dwScanThreadID[pLocalDevClass_USB->bCurDevListIndex]);
		else
			pLocalDevClass_USB->hScanThread[pLocalDevClass_USB->bCurDevListIndex] = CreateThread(NULL, 0, ScanThread_TYPE2, pLocalDevClass_USB->pMyLL_USB, 0, &pLocalDevClass_USB->dwScanThreadID[pLocalDevClass_USB->bCurDevListIndex]);
		
		
		SetThreadPriority(pLocalDevClass_USB->hScanThread[pLocalDevClass_USB->bCurDevListIndex], THREAD_PRIORITY_BELOW_NORMAL);
		if(!pLocalDevClass_USB->hScanThread[pLocalDevClass_USB->bCurDevListIndex])
		{
			MessageBox("Could not create scan thread", " ERROR -----", 0);
			EnableControls(this);
			return;
		}
		pLocalDevClass_USB->fScanThreadRunning[pLocalDevClass_USB->bCurDevListIndex] = TRUE;

		SetDlgItemText(IDC_RICHEDIT_MSGS, "Starting scan");
		cf.crTextColor = RGB(255, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		pRichEditMsgs->Invalidate(TRUE);
		SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);

		BOOLEAN fScanStartSuccess = FALSE;
		//start the scan
		// There are two ways to start the scan as shown here. When using only a single channel
		//  type of scan, the first is the easiest as well as the most efficient. With other types
		//  of scans the second way is usually more efficient but requires more parameters in the call.
		CWnd* pChanCombo		= GetDlgItem(IDC_COMBO_DEV_CHAN);	pChanCombo->EnableWindow(FALSE); 
		if(((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
			||	((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_DIGIN_SCAN))
		{


			if(pLocalDevClass_USB->pMyLL_USB->StartScan(pLocalDevClass_USB->usDefDevID) == TRUE)
			{
				pLocalDevClass_USB->m_afDevScanning[pLocalDevClass_USB->bCurDevListIndex] = TRUE;
				pLocalDevClass_USB->m_fAnyDevScanning = TRUE;
				pLocalDevClass_USB->fStartThreadTakingData[pLocalDevClass_USB->bCurDevListIndex] = TRUE;
				fScanStartSuccess = TRUE;
			}
		}
		else
		{
			BYTE fScanStartedList[32]; memset(fScanStartedList, 0, sizeof(fScanStartedList));
			BYTE bNumDevices = 1;
			if(pLocalDevClass_USB->pMyLL_USB->StartScan(bNumDevices, pLocalDevClass_USB->ausDevID, pLocalDevClass_USB->m_bScanType, pLocalDevClass_USB->m_bNumScanChans, fScanStartedList) == TRUE)
			{
				pLocalDevClass_USB->m_afDevScanning[pLocalDevClass_USB->bCurDevListIndex] = TRUE;
				pLocalDevClass_USB->m_fAnyDevScanning = TRUE;
				pLocalDevClass_USB->fStartThreadTakingData[pLocalDevClass_USB->bCurDevListIndex] = TRUE;
				fScanStartSuccess = TRUE;
			}
		}

		if(fScanStartSuccess)
		{
			cf.crTextColor = RGB(0, 0, 0); 
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Device is scanning");
			pRichEditMsgs->SetDefaultCharFormat(cf);

			CWnd* pSendDigoutBtn = GetDlgItem(IDC_BTN_SEND_DIGOUT);		pSendDigoutBtn->EnableWindow(TRUE); 
			CWnd* pGetDiginBtn = GetDlgItem(IDC_BTN_GET_DIGITAL_INPUT);	pGetDiginBtn->EnableWindow(TRUE);
			CWnd* pScanBtn = GetDlgItem(IDC_BTN_START_STOP_SCANNING);	pScanBtn->EnableWindow(TRUE);
			CWnd* pDevCombo = GetDlgItem(IDC_COMBO_DEV_ID);				pDevCombo->EnableWindow(TRUE);
			CWnd* pChanCombo = GetDlgItem(IDC_COMBO_DEV_CHAN);			pChanCombo->EnableWindow(TRUE);
			
			if(pLocalDevClass_USB->usDefDevID > 4990)
			{
				CWnd* pSendDAC_Btn = GetDlgItem(IDC_BTN_SEND_ANALOGOUT);		
				pSendDAC_Btn->EnableWindow(TRUE);
			}
		}
		else
		{
			pChanCombo->EnableWindow(TRUE); 
			pLocalDevClass_USB->fExitScanThreadRequest[pLocalDevClass_USB->bCurDevListIndex] = TRUE;

			EnableControls(this);
			cf.crTextColor = RGB(0, 0, 0); 
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Scan failed to start");
			pRichEditMsgs->SetDefaultCharFormat(cf);

			return; 
		}
	}
	else
	{
		if(fScanning)
		{
			if(pLocalDevClass_USB->fScanThreadRunning[pLocalDevClass_USB->bCurDevListIndex])
			{
				SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
				cf.crTextColor = RGB(255, 0, 0); 
				pRichEditMsgs->Invalidate(TRUE);
				pRichEditMsgs->SetDefaultCharFormat(cf);
				SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);

				pLocalDevClass_USB->fExitScanThreadRequest[pLocalDevClass_USB->bCurDevListIndex] = TRUE;
				DisableControls(this);

				while(pLocalDevClass_USB->fScanThreadRunning[pLocalDevClass_USB->bCurDevListIndex]) 
				{ Default(); }
			}

			pLocalDevClass_USB->pMyLL_USB->EndScan(pLocalDevClass_USB->usDefDevID);
			
			pLocalDevClass_USB->m_afDevScanning[pLocalDevClass_USB->bCurDevListIndex] = FALSE;
			BOOLEAN fAndDevScanning = FALSE;
			for(BYTE bIndex = 0; bIndex < 32; bIndex++)
			{
				if(pLocalDevClass_USB->m_afDevScanning[bIndex] == TRUE)
				{
					fAndDevScanning = TRUE;
					break;
				}
			}

			if(fAndDevScanning)
			{
				pLocalDevClass_USB->m_fAnyDevScanning = TRUE;
			}
			else
			{
				pLocalDevClass_USB->m_fAnyDevScanning = FALSE;
			}
			
			EnableControls(this);

			cf.crTextColor = RGB(0, 0, 0); 
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Scan ended");
			pRichEditMsgs->SetDefaultCharFormat(cf);
			SetDlgItemText(IDC_BTN_START_STOP_SCANNING, "Start scan");


		if(((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
			||	((pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_DIGIN_SCAN))
		{
			CWnd* pChanCombo		= GetDlgItem(IDC_COMBO_DEV_CHAN);	pChanCombo->EnableWindow(TRUE); 
		}

		}
	}
}

//#################################################################################\
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
// ## MAIN DIALOG CREATION     MAIN DIALOG CREATION    MAIN DIALOG CREATION ########  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/

BOOL CLL_USB_cDlg::OnInitDialog()
{
	char buff_LOCAL[255];
	CDialog::OnInitDialog();

	uiTimerInit = 1;
	m_ComboRateChanged = FALSE;

//----------------------------------------------\
// #### set some global variables to NULL >>>>>>>>
//----------------------------------------------/
	memset(pLocalDevClass_USB->m_afDevScanning, 0, sizeof(pLocalDevClass_USB->m_afDevScanning));
	pLocalDevClass_USB->bCurDevListIndex = 0;
	memset(pLocalDevClass_USB->m_bScanType, 0, sizeof(pLocalDevClass_USB->m_bScanType));
	pLocalDevClass_USB->m_fAnyDevScanning = FALSE;
	pLocalDevClass_USB->usDefDevID = 0;
	pLocalDevClass_USB->bDefChan = 0;
	pLocalDevClass_USB->dblDefRate = 0.0;
	pLocalDevClass_USB->bCurNumDevices = 0;

	for(BYTE bIndex = 0; bIndex < 32; bIndex++)
	{
		pLocalDevClass_USB->fScanThreadRunning[bIndex] = FALSE;
		pLocalDevClass_USB->fExitScanThreadRequest[bIndex] = FALSE;
		//pLocalDevClass_USB->usNumScanPntsToRequest[bIndex] = 0;
		pLocalDevClass_USB->m_bNumScanChans[bIndex] = 0;
		pLocalDevClass_USB->m_bScanType[bIndex] = 0;
		pLocalDevClass_USB->fStartThreadTakingData[bIndex] = FALSE;
		pLocalDevClass_USB->hScanThread[bIndex] = NULL;
	}
	pMainDlg = this;
	hMainDlg = m_hWnd;


//----------------------------------------------\
// #### Read .ini file contents >>>>>>>>>>>>>>>>>>
//----------------------------------------------/
	char szDirInfo[1024];
	sprintf(szDirInfo, "");
	GetCurrentDirectory(sizeof(szDirInfo), szDirInfo);
	strcat(szDirInfo, "\\My_USB.ini");

	pLocalDevClass_USB->usDefNumDevInIniFile = (BYTE)GetPrivateProfileInt("NumDevices", "Cnt", 0, szDirInfo);
	if(pLocalDevClass_USB->usDefNumDevInIniFile > 0)
	{
		pLocalDevClass_USB->bCurNumDevices = pLocalDevClass_USB->usDefNumDevInIniFile;
		if(pLocalDevClass_USB->usDefNumDevInIniFile == 1)
		{
			pLocalDevClass_USB->usDefDevID = (USHORT)GetPrivateProfileInt("Dev0", "DevID", 0, szDirInfo);
			pLocalDevClass_USB->ausDevID[0] = pLocalDevClass_USB->usDefDevID;

			pLocalDevClass_USB->bDefChan = (BYTE)GetPrivateProfileInt("Dev0", "Chan", 1, szDirInfo);
			pLocalDevClass_USB->abChan[0] = pLocalDevClass_USB->bDefChan;

			char szVoltage[128];
			GetPrivateProfileString("Dev0", "Rate", "100", szVoltage, 8, szDirInfo);
			pLocalDevClass_USB->dblDefRate = atof(szVoltage);
			pLocalDevClass_USB->adblDevRate[0] = pLocalDevClass_USB->dblDefRate;

			pLocalDevClass_USB->m_bDefDAC = (BYTE)GetPrivateProfileInt("Dev0", "CurDAC", 0, szDirInfo);
			pLocalDevClass_USB->m_abDefDAC[0] = pLocalDevClass_USB->m_bDefDAC;

			pLocalDevClass_USB->m_bDefScanType = (BYTE)GetPrivateProfileInt("Dev0", "ScanType", 1, szDirInfo);
			if(		(pLocalDevClass_USB->m_bDefScanType != CMND_SINGLE_CHAN_SCAN)
				&&	(pLocalDevClass_USB->m_bDefScanType != CMND_SINGLE_CHAN_DIGIN_SCAN)
				&&	(pLocalDevClass_USB->m_bDefScanType != CMND_MULTI_CHAN_SCAN)
				&&	(pLocalDevClass_USB->m_bDefScanType != CMND_MULTI_CHAN_CAL_SCAN)
				&&	(pLocalDevClass_USB->m_bDefScanType != CMND_MULTI_CHAN_DIGIN_SCAN)
				&&	(pLocalDevClass_USB->m_bDefScanType != CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
			{ pLocalDevClass_USB->m_bDefScanType = CMND_SINGLE_CHAN_SCAN; }

			pLocalDevClass_USB->m_bScanType[0] = pLocalDevClass_USB->m_bDefScanType;

			pLocalDevClass_USB->m_bDefNumScanChans = (BYTE)GetPrivateProfileInt("Dev0", "NumScanChans", 1, szDirInfo);
			if(pLocalDevClass_USB->m_bDefNumScanChans > 1)
			{
				if(		(pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_SCAN) || (pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_DIGIN_SCAN))
				{ pLocalDevClass_USB->m_bDefNumScanChans = 1; }
				else
				{
					if(pLocalDevClass_USB->usDefDevID < 4990)
					{ if(pLocalDevClass_USB->m_bDefNumScanChans > 4) pLocalDevClass_USB->m_bDefNumScanChans = 4; }
					else
					{ if(pLocalDevClass_USB->m_bDefNumScanChans > 8) pLocalDevClass_USB->m_bDefNumScanChans = 8; }
				}
			}

			pLocalDevClass_USB->m_bNumScanChans[0] = pLocalDevClass_USB->m_bDefNumScanChans;

			CComboBox* pComboDAC_Num = (CComboBox*)GetDlgItem(IDC_COMBO_DAC);
			//pComboDAC_Num->AddString((LPCTSTR)"1");
			sprintf(buff_LOCAL, "%d", pLocalDevClass_USB->m_bDefDAC);
			SetDlgItemText(IDC_COMBO_DAC, buff_LOCAL); 


			CComboBox* pComboScanChanCnt = (CComboBox*)GetDlgItem(IDC_COMBO_SCAN_NUM_CHANS);

			pComboScanChanCnt->AddString((LPCTSTR)"1");
			SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "1"); 

			if(		(pLocalDevClass_USB->m_bDefScanType == (BYTE)CMND_SINGLE_CHAN_DIGIN_SCAN)
				||	(pLocalDevClass_USB->m_bDefScanType == (BYTE)CMND_MULTI_CHAN_DIGIN_SCAN)
				||	(pLocalDevClass_USB->m_bDefScanType == (BYTE)CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
			{ m_pDiginScanChkBox.SetCheck(1); }


			if(		(pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_SCAN) 
				||	(pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_DIGIN_SCAN))
			{ 
				m_pMultiScanChanChkBox.SetCheck(0);
				m_pCalScanChkBox.EnableWindow(FALSE);
				UpdateNumScanChansCntrl();
			}
			else
			{
				m_pMultiScanChanChkBox.SetCheck(1); m_pCalScanChkBox.EnableWindow(TRUE);

				if(		(pLocalDevClass_USB->m_bDefScanType == CMND_MULTI_CHAN_CAL_SCAN) ||	(pLocalDevClass_USB->m_bDefScanType == CMND_MULTI_CHAN_DIGIN_CAL_SCAN))
				{ m_pCalScanChkBox.SetCheck(1); }

				UpdateNumScanChansCntrl();
			}
		}
		else // mulitple device listing not yet fully implemented in this sample code.
		{
			char devBuff[32];
			char devBuff_TEMP[4];
			for(BYTE bIndex = 0; bIndex < pLocalDevClass_USB->usDefNumDevInIniFile; bIndex++)
			{
				sprintf(devBuff, "Dev");
				sprintf(devBuff_TEMP, "%d", bIndex);
				strcat(devBuff, devBuff_TEMP);
				//usDefDevID[bIndex] = (USHORT)GetPrivateProfileInt("Dev0", "DevID", 0, szDirInfo);
				//bDefChan[bIndex] = (BYTE)GetPrivateProfileInt("Dev0", "Chan", 1, szDirInfo);
				//char szVoltage[128];
				//GetPrivateProfileString("M301", "Rate", "100", szVoltage, 8, szDirInfo);
				//dblDefRate[bIndex] = atof(szVoltage);
			}
		}
	}


	pRichEditMsgs = (CRichEditCtrl*)GetDlgItem(IDC_RICHEDIT_MSGS);

	CHARFORMAT cf;
	cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;

	SetDlgItemText(IDC_RICHEDIT_MSGS, "Start by pressing the  'Initialize'  button.");

	char szWinTxtBuff[128];

	sprintf(szWinTxtBuff, " LL_USB (");

	pLocalDevClass_USB->uiDefOS_Code = 0;
	OSVERSIONINFO structOS_ver;
	structOS_ver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&structOS_ver);
	if(structOS_ver.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS)
		pLocalDevClass_USB->uiDefOS_Code = pLocalDevClass_USB->uiDefOS_Code | LL_Win95 | LL_Win98 | LL_WinME;
	else
		pLocalDevClass_USB->uiDefOS_Code = pLocalDevClass_USB->uiDefOS_Code | LL_Win2k | LL_WinXP | LL_WinNT;

	while(TRUE)
	{
		if(pLocalDevClass_USB->uiDefOS_Code & LL_Win95) {strcat(szWinTxtBuff, "Win9x/ME)"); break;}
		if(pLocalDevClass_USB->uiDefOS_Code & LL_Win98) {strcat(szWinTxtBuff, "Win9x/ME)"); break;}
		if(pLocalDevClass_USB->uiDefOS_Code & LL_WinME) {strcat(szWinTxtBuff, "Win9x/ME)"); break;}
		if(pLocalDevClass_USB->uiDefOS_Code & LL_Win2k) {strcat(szWinTxtBuff, "Win2k/XP/NT)"); break;}
		if(pLocalDevClass_USB->uiDefOS_Code & LL_WinXP) {strcat(szWinTxtBuff, "Win2k/XP/NT)"); break;}
		if(pLocalDevClass_USB->uiDefOS_Code & LL_WinNT) {strcat(szWinTxtBuff, "Win2k/XP/NT)"); break;}
		strcat(szWinTxtBuff, "Unknown)"); break;
	}

	SetWindowText(szWinTxtBuff); 

	COLORREF cr = GetSysColor(COLOR_BTNFACE);
	pRichEditScanStat->SetBackgroundColor(FALSE, cr );

	cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;

	sprintf(buff_LOCAL, "%4.2lf", pLocalDevClass_USB->dblDefRate);
	SetDlgItemText(IDC_COMBO_DEV_RATE, buff_LOCAL);

	SetDlgItemText(IDC_BTN_START_STOP_SCANNING, "Start scan");
	
	sprintf(buff_LOCAL, "%u", pLocalDevClass_USB->usDefDevID);
	SetDlgItemText(IDC_COMBO_DEV_ID, buff_LOCAL);

	if(pLocalDevClass_USB->usDefDevID < 4990)
	{
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 0, (LPARAM)"0"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 1, (LPARAM)"1"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 2, (LPARAM)"6"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 3, (LPARAM)"7"); 
	}
	else
	{
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 0, (LPARAM)"0"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 1, (LPARAM)"1"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 2, (LPARAM)"2"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 3, (LPARAM)"3"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 4, (LPARAM)"4"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 5, (LPARAM)"5"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 6, (LPARAM)"6"); 
		SendDlgItemMessage(IDC_COMBO_DEV_CHAN, CB_ADDSTRING, 7, (LPARAM)"7"); 
	}
	sprintf(buff_LOCAL, "%u", pLocalDevClass_USB->bDefChan);
	SetDlgItemText(IDC_COMBO_DEV_CHAN, buff_LOCAL);

	CWnd* pInitBtn = (CWnd*)GetDlgItem(IDC_BTN_INIT_ALL);
	pInitBtn->SetFocus(); 
//*/
	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

///*
	BOOLEAN fDoInitOnLoad = FALSE;
	fDoInitOnLoad = (BOOLEAN)GetPrivateProfileInt("Startup", "InitOnLoad", 0, szDirInfo);

	if(fDoInitOnLoad) OnBtnInitAll();
	else
	{
		DisableControls(this);
		pInitBtn->EnableWindow(TRUE);
		CWnd* pExitBtn = GetDlgItem(IDC_BTN_EXIT);
		pExitBtn->EnableWindow(TRUE);
	}

	pScanDataDlg = new ScanDataDlg();

	//TIM NOTE: Need to do something else below
	if(pScanDataDlg->Create(IDD_DLG_SCAN_DATA, 0) == 0) MessageBox("FAILED TO CREATE SCAN DIALOG", " NOTICE -----", 0);
	pScanDataDlg->ShowWindow(SW_HIDE);
	SetDlgItemText(IDC_EDIT_DEV_TYPE, "USB");
//*/

	
	// TODO: Add extra initialization here
	return TRUE;  // return TRUE  unless you set the focus to a control
}


//****************************************************************\
//================================================================*\
//==== DisplayErrorString FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
void DisplayErrorString(CLL_USB_cDlg* pDlg, UINT usDevID)
{ 
	UINT uiErrorCode;
	pDlg->pLocalDevClass_USB->pMyLL_USB->GetLastDevError(usDevID, &uiErrorCode);

	CString szErrMsg = "Call failed\nError code: "; 
	CString szErrStr; 

	switch(uiErrorCode)
	{
		case ERR_NO_ERROR: szErrStr = "ERR_NO_ERROR"; break;
		case ERR_IVALID_OS: szErrStr = "ERR_IVALID_OS"; break;
		case ERR_DLL_NOT_FOUND: szErrStr = "ERR_DLL_NOT_FOUND"; break;
		case ERR_DLL_FUNCTION_NOT_FOUND: szErrStr = "ERR_DLL_FUNCTION_NOT_FOUND"; break;
		case ERR_NO_DEVICES_INITIALIZED: szErrStr = "ERR_NO_DEVICES_INITIALIZED"; break;
		case ERR_MEM_ALLOC_ERROR: szErrStr = "ERR_MEM_ALLOC_ERROR"; break;
		case ERR_INVALID_DEV_ID: szErrStr = "ERR_INVALID_DEV_ID"; break;
		case ERR_DEV_NOT_FOUND: szErrStr = "ERR_DEV_NOT_FOUND"; break;
		case ERR_FAILED_INIT: szErrStr = "ERR_FAILED_INIT"; break;
		case ERR_DEV_NOT_INITIALIZED: szErrStr = "ERR_DEV_NOT_INITIALIZED"; break;
		case ERR_FAILED_IO: szErrStr = "ERR_FAILED_IO"; break;
		case ERR_FAILED_SCAN_STARTUP: szErrStr = "ERR_FAILED_SCAN_STARTUP"; break;
		case ERR_DEV_NOT_SCANNING: szErrStr = "ERR_DEV_NOT_SCANNING"; break;
		case ERR_DEV_BUSY_SCANNING: szErrStr = "ERR_DEV_BUSY_SCANNING"; break;
		case ERR_UNKNOWN_ERROR: szErrStr = "ERR_UNKNOWN_ERROR"; break;
		default: szErrStr = "ERR_UNKNOWN"; break;
	}

	szErrMsg += szErrStr; 
	SetDlgItemText(pDlg->m_hWnd, IDC_RICHEDIT_MSGS, szErrMsg); 
}




//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
// ###  DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE   DEV_RATE #  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//****************************************************************\
//================================================================*\
//==== OnSelchangeComboDevRate FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnSelchangeComboDevRate() 
{
	char buff[128];
	DlgDirSelectComboBox(buff, IDC_COMBO_DEV_RATE );

	DOUBLE dblNewRate = atof(buff);
	if((dblNewRate < 50) || (dblNewRate > 1000))
	{
		sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
		SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
		m_ComboRateChanged = FALSE;
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Invalide rate!"); 

		return;
	}

	if(dblNewRate == pLocalDevClass_USB->dblDefRate)
	{
		m_ComboRateChanged = FALSE;
		return;
	}

	CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;
	SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
	cf.crTextColor = RGB(255, 0, 0); 
	pRichEditMsgs->SetDefaultCharFormat(cf);
	pRichEditMsgs->Invalidate(TRUE);
	SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);

	if(!pLocalDevClass_USB->pMyLL_USB->ChangeCurDevRate(pLocalDevClass_USB->usDefDevID, &dblNewRate))
	{
		sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
		SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
		cf.crTextColor = RGB(0, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID); 
	}
	else
	{
		pLocalDevClass_USB->dblDefRate = dblNewRate;
		cf.crTextColor = RGB(0, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Rate change success");
	}

	return;
}


//****************************************************************\
//================================================================*\
//==== OnEditupdateComboDevRate FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnEditupdateComboDevRate() 
{ 
	CWnd* pRateBtn = GetDlgItem(IDC_BTN_SEND_RATE);
	pRateBtn->ShowWindow(SW_SHOW);
	m_ComboRateChanged = TRUE; 
}


//****************************************************************\
//================================================================*\
//==== OnBtnSendRate FUNCTION =====================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnSendRate() 
{
	if(m_ComboRateChanged)
	{
		CWnd* pRateBtn = GetDlgItem(IDC_BTN_SEND_RATE);
		pRateBtn->ShowWindow(SW_HIDE);

		char buff[128];
		GetDlgItemText(IDC_COMBO_DEV_RATE, buff, sizeof(buff));
		DOUBLE dblNewRate = atof(buff);
		if((dblNewRate < 50) || (dblNewRate > 1000))
		{
			sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
			SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
			m_ComboRateChanged = FALSE;
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Invalide rate!"); 

			return;
		}

		if(dblNewRate == pLocalDevClass_USB->dblDefRate)
		{
			m_ComboRateChanged = FALSE;
			return;
		}

		CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
		cf.dwMask = CFM_COLOR;
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
		cf.crTextColor = RGB(255, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		pRichEditMsgs->Invalidate(TRUE);
		SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);

		if(!pLocalDevClass_USB->pMyLL_USB->ChangeCurDevRate(pLocalDevClass_USB->usDefDevID, &dblNewRate))
		{
			sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
			SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
			cf.crTextColor = RGB(0, 0, 0); 
			pRichEditMsgs->SetDefaultCharFormat(cf);
			DisplayErrorString(this, pLocalDevClass_USB->usDefDevID); 
		}
		else
		{
			pLocalDevClass_USB->dblDefRate = dblNewRate;
			cf.crTextColor = RGB(0, 0, 0); 
			pRichEditMsgs->SetDefaultCharFormat(cf);
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Rate change success");
		}
	}

	return;
}





//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
// ###  DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID   DEV_ID ######  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//****************************************************************\
//================================================================*\
//==== OnEditchangeComboDevId FUNCTION ============================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnEditchangeComboDevId() 
{
	char buff[128];
	sprintf(buff, "%u", pLocalDevClass_USB->usDefDevID);
	SetDlgItemText(IDC_COMBO_DEV_ID, buff);
}



//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
// ###  CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN   CHAN  CHAN ##  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//****************************************************************\
//================================================================*\
//==== OnSelchangeComboDevChan FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnSelchangeComboDevChan() 
{
	char buff[128];
	DlgDirSelectComboBox(buff, IDC_COMBO_DEV_CHAN );

	BYTE bNewChan = atoi(buff);

	if(bNewChan == pLocalDevClass_USB->bDefChan)
	{
		//MessageBox("bNewChan == bDefChan", " OnSelchangeComboDevChan -----", 0);
		return;
	}

	CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;
	SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
	cf.crTextColor = RGB(255, 0, 0); 
	pRichEditMsgs->SetDefaultCharFormat(cf);
	pRichEditMsgs->Invalidate(TRUE);
	SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);


	if(!pLocalDevClass_USB->pMyLL_USB->SetCurChan(pLocalDevClass_USB->usDefDevID, bNewChan))
	{
		//MessageBox("!pMyLL_USB->", " OnSelchangeComboDevChan -----", 0);
		sprintf(buff, "%b", pLocalDevClass_USB->bDefChan);
		SetDlgItemText(IDC_COMBO_DEV_CHAN, buff);
		cf.crTextColor = RGB(0, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		DisplayErrorString(this, pLocalDevClass_USB->usDefDevID); 
	}
	else
	{
		pLocalDevClass_USB->bDefChan = bNewChan;
		cf.crTextColor = RGB(0, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Channel change success");

		if(pLocalDevClass_USB->fScanThreadRunning[pMainDlg->pLocalDevClass_USB->bCurDevListIndex])
		{
			if((pLocalDevClass_USB->m_bScanType[pMainDlg->pLocalDevClass_USB->bCurDevListIndex]) == CMND_SINGLE_CHAN_SCAN)
			{
				CWnd* pCurScanChanDataBox = NULL; 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN0); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN2); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN3); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN4); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN5); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(FALSE); 
				pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(FALSE); 
				switch(pLocalDevClass_USB->bDefChan)
				{
					case 0: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN0); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 1: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN1); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 2: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN2); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 3: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN3); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 4: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN4); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 5: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN5); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 6: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN6); pCurScanChanDataBox->EnableWindow(TRUE); break;
					case 7: pCurScanChanDataBox = pScanDataDlg->GetDlgItem(IDC_EDIT_SD_SCAN_CHAN7); pCurScanChanDataBox->EnableWindow(TRUE); break;
				}
			}
		}
	}
}



//****************************************************************\
//================================================================*\
//==== OnEditchangeComboDevChan FUNCTION ==========================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnEditchangeComboDevChan() 
{
	char buff[128];
	sprintf(buff, "%d", pLocalDevClass_USB->bDefChan);
	SetDlgItemText(IDC_COMBO_DEV_CHAN, buff);
}










//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
// ###  MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC   MISC  MIS ###  
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//##################################################################################
//#################################################################################/

//****************************************************************\
//================================================================*\
//==== OnOK FUNCTION ==============================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnOK() 
{
	MSG msg;
	PeekMessage( &msg, m_hWnd, NULL, NULL, PM_NOREMOVE); 
}


//****************************************************************\
//================================================================*\
//==== class CAboutDlg ============================================*>
//================================================================*/
/*****************************************************************/
/////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//****************************************************************\
//================================================================*\
//==== class CAboutDlg CONSTRUCOTR  ===============================*>
//================================================================*/
/*****************************************************************/
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLL_USB_cDlg dialog

CLL_USB_cDlg::CLL_USB_cDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLL_USB_cDlg::IDD, pParent)
{
	//6-23-02 #############
	pLocalDevClass_USB = new LocalDevClass_USB();
	pLocalDevClass_USB->pMyLL_USB = NULL;
	//6-23-02 #############

//MessageBox("Put anything here", " CLL_USB_cDlg -----", 0);
	//{{AFX_DATA_INIT(CLL_USB_cDlg)
	m_strRate = _T("");
	m_IsMultiChanChecked = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CLL_USB_cDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLL_USB_cDlg)
	DDX_Control(pDX, IDC_EDIT_ANALOGOUT, m_VoltsDAC);
	DDX_Control(pDX, IDC_CHK_SCAN_CAL_SCAN, m_pCalScanChkBox);
	DDX_Control(pDX, IDC_CHK_SCAN_DIGIN, m_pDiginScanChkBox);
	DDX_Control(pDX, IDC_CHK_SCAN_MULTI_CHAN, m_pMultiScanChanChkBox);
	DDX_Control(pDX, IDC_PROGRESS_INIT, m_ProgressCntrl);
	DDX_CBString(pDX, IDC_COMBO_DEV_RATE, m_strRate);
	DDV_MaxChars(pDX, m_strRate, 7);
	DDX_Check(pDX, IDC_CHK_SCAN_MULTI_CHAN, m_IsMultiChanChecked);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLL_USB_cDlg, CDialog)
	//{{AFX_MSG_MAP(CLL_USB_cDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_INIT_ALL, OnBtnInitAll)
	ON_BN_CLICKED(IDC_BTN_GET_ONE_VOLTAGE, OnBtnGetOneVoltage)
	ON_BN_CLICKED(IDC_BTN_SEND_DIGOUT, OnBtnSendDigout)
	ON_BN_CLICKED(IDC_BTN_GET_DIGITAL_INPUT, OnBtnGetDigitalInput)
	ON_BN_CLICKED(IDC_BTN_START_STOP_SCANNING, OnBtnStartStopScanning)
	ON_WM_CTLCOLOR()
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	ON_CBN_SELCHANGE(IDC_COMBO_DEV_RATE, OnSelchangeComboDevRate)
	ON_BN_CLICKED(IDC_BTN_EXIT, OnBtnExit)
	ON_CBN_EDITUPDATE(IDC_COMBO_DEV_RATE, OnEditupdateComboDevRate)
	ON_BN_CLICKED(IDC_BTN_SEND_RATE, OnBtnSendRate)
	ON_CBN_EDITCHANGE(IDC_COMBO_DEV_CHAN, OnEditchangeComboDevChan)
	ON_CBN_EDITCHANGE(IDC_COMBO_DEV_ID, OnEditchangeComboDevId)
	ON_CBN_SELCHANGE(IDC_COMBO_DEV_CHAN, OnSelchangeComboDevChan)
	ON_WM_MOVE()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_CHK_SCAN_MULTI_CHAN, OnChkScanMultiChan)
	ON_BN_CLICKED(IDC_CHK_SCAN_CAL_SCAN, OnChkScanCalScan)
	ON_BN_CLICKED(IDC_CHK_SCAN_DIGIN, OnChkScanDigin)
	ON_CBN_EDITCHANGE(IDC_COMBO_SCAN_NUM_CHANS, OnEditchangeComboScanNumChans)
	ON_CBN_EDITCHANGE(IDC_COMBO_DAC, OnEditchangeComboDac)
	ON_BN_CLICKED(IDC_BTN_SEND_ANALOGOUT, OnBtnSendAnalogout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLL_USB_cDlg message handlers




//****************************************************************\
//================================================================*\
//==== OnPaint FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnSysCommand(UINT nID, LPARAM lParam)
{

	// Check for system close button (don't allow it to close).
	if ((nID & 0xFFF0) == 0xF060)
	{
		// TIM NOTE: NEED TO DO CLEANUP TO EXIT HERE.
		return;
	}

	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}


//****************************************************************\
//================================================================*\
//==== OnPaint FUNCTION ===========================================*>
//================================================================*/
/*****************************************************************/
// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CLL_USB_cDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


//****************************************************************\
//================================================================*\
//==== OnQueryDragIcon FUNCTION ===================================*>
//================================================================*/
/*****************************************************************/
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLL_USB_cDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//****************************************************************\
//================================================================*\
//==== DisplayErrorString FUNCTION ================================*>
//================================================================*/
/*****************************************************************/
HBRUSH CLL_USB_cDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
   switch (nCtlColor)
   {
      case CTLCOLOR_STATIC:
      //     pDC->SetTextColor (RGB(128,0,0)); // red text.
      //     hbr = (HBRUSH)GetStockObject(NULL_BRUSH);
           break;

      case CTLCOLOR_BTN:
           pDC->SetTextColor (RGB(128,0,0)); // red text.
           hbr = (HBRUSH)GetStockObject(NULL_BRUSH);
           break;
      default:
           hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor); 
           break;
   }

   return hbr;

}




//****************************************************************\
//================================================================*\
//==== OnShowWindow FUNCTION ======================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
}



//****************************************************************\
//================================================================*\
//==== OnBtnExit FUNCTION =========================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnBtnExit() 
{
	if(pLocalDevClass_USB->pMyLL_USB != NULL)
		pLocalDevClass_USB->pMyLL_USB->~MyLL_USB();	
	CDialog::OnOK();
}



//****************************************************************\
//================================================================*\
//==== OnMove FUNCTION ============================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::OnMove(int x, int y) 
{
//MessageBox("Put anything here", " OnMove -----", 0);
	CDialog::OnMove(x, y);
	if(pLocalDevClass_USB->pMyLL_USB == NULL) return;

	if(pScanDataDlg->IsWindowEnabled())
	{
		WINDOWPLACEMENT winPlacement;
		pScanDataDlg->GetWindowPlacement(&winPlacement);
		RECT rectMainDlg;
		RECT rectScanDatDlg;
		GetWindowRect(&rectMainDlg);
		pScanDataDlg->GetWindowRect(&rectScanDatDlg);
		int nWidth = rectScanDatDlg.right - rectScanDatDlg.left;
		int nHeight = rectScanDatDlg.bottom - rectScanDatDlg.top;
		int iNewX = rectMainDlg.left - nWidth;
		int iNewY = rectMainDlg.top;
		pScanDataDlg->MoveWindow ( iNewX, iNewY, nWidth, nHeight, TRUE );
	}
}

void CLL_USB_cDlg::OnButton1() 
{
	pScanDataDlg->ShowWindow(SW_SHOW | SW_SHOWNORMAL);
}



//****************************************************************\
//================================================================*\
//==== UpdateNumScanChansCntrl FUNCTION ===========================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::UpdateNumScanChansCntrl()
{
	CComboBox* pComboScanChanCnt = (CComboBox*)GetDlgItem(IDC_COMBO_SCAN_NUM_CHANS);
	//char gbuff[255];

	int iItemCnt = pComboScanChanCnt->GetCount(); 
	int iIndex;
	if(iItemCnt)

	for(iIndex = iItemCnt - 1; iIndex >= 0; iIndex--)
	{
		pComboScanChanCnt->DeleteString(iIndex); 
	}

	pComboScanChanCnt->AddString((LPCTSTR)"1");
	SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "1"); 

	if(		(pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_SCAN) 
		||	(pLocalDevClass_USB->m_bDefScanType == CMND_SINGLE_CHAN_DIGIN_SCAN))
	{ 
		pLocalDevClass_USB->m_bDefNumScanChans = 1;
		pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex] = 1;
		return; 
	}

	pComboScanChanCnt->AddString((LPCTSTR)"2"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "2");  
	pComboScanChanCnt->AddString((LPCTSTR)"3"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "3");  
	pComboScanChanCnt->AddString((LPCTSTR)"4"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "4");  

	if(pLocalDevClass_USB->usDefDevID > 4990)
	{
		pComboScanChanCnt->AddString((LPCTSTR)"5"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "5"); 
		pComboScanChanCnt->AddString((LPCTSTR)"6"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "6"); 
		pComboScanChanCnt->AddString((LPCTSTR)"7"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "7"); 
		pComboScanChanCnt->AddString((LPCTSTR)"8"); SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, "8"); 
	}
}



//****************************************************************\
//================================================================*\
//==== HandleScanChks FUNCTION ====================================*>
//================================================================*/
/*****************************************************************/
void CLL_USB_cDlg::HandleScanChks(void)
{
	pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_SINGLE_CHAN_SCAN;		
	CWnd* pScanCalChk = GetDlgItem(IDC_CHK_SCAN_CAL_SCAN);		
	pScanCalChk->EnableWindow(FALSE);
	
	//m_bDefScanType = CMND_SINGLE_CHAN_SCAN;						
	if(m_pDiginScanChkBox.GetCheck())
	{
		if(!m_pMultiScanChanChkBox.GetCheck())
		{
			//4*) CMND_SINGLE_CHAN_DIGIN_SCAN
			pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_SINGLE_CHAN_DIGIN_SCAN;		/*(4)*/ 
			m_pCalScanChkBox.SetCheck(0);
			pScanCalChk->EnableWindow(FALSE);
		}
		else
		{
			if(!m_pCalScanChkBox.GetCheck())
			{
				//5) CMND_MULTI_CHAN_DIGIN_SCAN
				pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_MULTI_CHAN_DIGIN_SCAN;
				pScanCalChk->EnableWindow(TRUE);
			}
			else
			{
				//6) CMND_MULTI_CHAN_DIGIN_CAL_SCAN
				pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_MULTI_CHAN_DIGIN_CAL_SCAN;
				pScanCalChk->EnableWindow(TRUE);
			}
		}
		UpdateNumScanChansCntrl();
		return;
	}

	// handle non-digin multi or single
	if(!m_pMultiScanChanChkBox.GetCheck())
	{
		//1)* CMND_SINGLE_CHAN_SCAN - set at top
		pScanCalChk->EnableWindow(FALSE);
		m_pCalScanChkBox.SetCheck(0);
		UpdateNumScanChansCntrl();
		return;													
	}

	if(m_pMultiScanChanChkBox.GetCheck())
	{
		if(m_pCalScanChkBox.GetCheck())
		{
			//3) CMND_MULTI_CHAN_CAL_SCAN
			pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_MULTI_CHAN_CAL_SCAN;		
			pScanCalChk->EnableWindow(TRUE);
		}
		else
		{
			//2) CMND_MULTI_CHAN_SCAN
			pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex] = pLocalDevClass_USB->m_bDefScanType = CMND_MULTI_CHAN_SCAN;		
			pScanCalChk->EnableWindow(TRUE);
		}
	}
	UpdateNumScanChansCntrl();
	return;
}

void testScanChecks(CLL_USB_cDlg* pDlg) { char buff[128]; sprintf(buff, "type: %X", pDlg->pLocalDevClass_USB->m_bDefScanType); MessageBox(GetForegroundWindow(), buff, " NOTICE -----", 0); }

void CLL_USB_cDlg::OnChkScanMultiChan() 
{ HandleScanChks(); //testScanChecks(this);
}

void CLL_USB_cDlg::OnChkScanCalScan() 
{ HandleScanChks(); //testScanChecks(this);
}

void CLL_USB_cDlg::OnChkScanDigin() 
{ HandleScanChks(); //testScanChecks(this);
}

void CLL_USB_cDlg::OnEditchangeComboScanNumChans() 
{
	char buff[128]; sprintf(buff, "%d", pLocalDevClass_USB->m_bDefNumScanChans);
	SetDlgItemText(IDC_COMBO_SCAN_NUM_CHANS, buff);
}



/*
if(!fDlgMsgBoxShownOnce)
{
	fDlgMsgBoxShownOnce = TRUE;
	char gbuff[255];
	sprintf(gbuff, "TYPE: %d, ChanCnt: %d", 
			pLocalDevClass_USB->m_bScanType[pLocalDevClass_USB->bCurDevListIndex],
			pLocalDevClass_USB->m_bNumScanChans[pLocalDevClass_USB->bCurDevListIndex]);
	MessageBox(gbuff, " NOTICE -----", 0);
}
*/

//MessageBox("Put anything here", " NOTICE -----", 0);
//MessageBox(GetForegroundWindow(), "Put anything here", " NOTICE -----", 0);










/*
	if(m_ComboRateChanged)
	{
		CWnd* pRateBtn = GetDlgItem(IDC_BTN_SEND_RATE);
		pRateBtn->ShowWindow(SW_HIDE);

		char buff[128];
		GetDlgItemText(IDC_COMBO_DEV_RATE, buff, sizeof(buff));
		DOUBLE dblNewRate = atof(buff);
		if((dblNewRate < 50) || (dblNewRate > 1000))
		{
			sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
			SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
			m_ComboRateChanged = FALSE;
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Invalide rate!"); 

			return;
		}

		if(dblNewRate == pLocalDevClass_USB->dblDefRate)
		{
			m_ComboRateChanged = FALSE;
			return;
		}

		CHARFORMAT cf; cf.cbSize = sizeof(CHARFORMAT);
		cf.dwMask = CFM_COLOR;
		SetDlgItemText(IDC_RICHEDIT_MSGS, "Please wait . . . .");
		cf.crTextColor = RGB(255, 0, 0); 
		pRichEditMsgs->SetDefaultCharFormat(cf);
		pRichEditMsgs->Invalidate(TRUE);
		SendDlgItemMessage(IDC_RICHEDIT_MSGS, WM_PAINT, 0, 0);

		if(!pLocalDevClass_USB->pMyLL_USB->ChangeCurDevRate(pLocalDevClass_USB->usDefDevID, &dblNewRate))
		{
			sprintf(buff, "%4.2lf", pLocalDevClass_USB->dblDefRate);
			SetDlgItemText(IDC_COMBO_DEV_RATE, buff);
			cf.crTextColor = RGB(0, 0, 0); 
			pRichEditMsgs->SetDefaultCharFormat(cf);
			DisplayErrorString(this, pLocalDevClass_USB->usDefDevID); 
		}
		else
		{
			pLocalDevClass_USB->dblDefRate = dblNewRate;
			cf.crTextColor = RGB(0, 0, 0); 
			pRichEditMsgs->SetDefaultCharFormat(cf);
			SetDlgItemText(IDC_RICHEDIT_MSGS, "Rate change success");
		}
	}

	return;
*/







